program Iskanje; { RTK 1993.2.3 }

const MaxN = 100;
var t: array[1..MaxN, 1..MaxN] of integer; 

procedure Poisci(n, Element: integer); 
var x, y, Stevec: integer; 
begin
  x := 1; 
  y := n; 
  Stevec := 0; 
  while (x <= n) and (y >= 1) do begin 
    if Element > t[x, y] then x := x + 1 
    else if Element < t[x, y] then y := y - 1 
    else begin 
      WriteLn('Nael iskano vrednost ', Element, ' v celici t[', x, ',', y, '].'); 
      Stevec := Stevec + 1; 
      x := x + 1; 
    end; {if}
  end; {while}
  WriteLn('t. najdenih primerkov vrednosti ', Element, ': ', Stevec, '.'); 
end; {Poisci} 

var f: text; n, i, j, Iskani: integer;
begin {Iskanje}
  if ParamCount >= 1 then Assign(f, ParamStr(1))
  else Assign(f, 'rtk93s2n3.in');
  Reset(f);

  while not Eof(f) do begin
    ReadLn(f, n, Iskani); if n <= 0 then break;
    for i := 1 to n do begin
      for j := 1 to n do Read(f, t[i, j]);
      for j := 2 to n do Assert(t[i, j-1] < t[i, j]);
      if i > 1 then for j := 1 to n do Assert(t[i-1, j] < t[i, j]);
      ReadLn(f);
    end; {for i}
    Poisci(n, Iskani);
  end; {while}

  Close(f);
end. {Iskanje}
