@echo off
rem   ------------------------------------------------------------------
rem   Paketna datoteka za testiranje reitve naloge RTK 1995.Z
rem   (1. zakljuno tekmovanje iz znanja raunalnitva)
rem   ------------------------------------------------------------------
rem   Na trenutnem direktoriju morajo biti prisotne naslednje datoteke:
rem   - rtk95sZ.pas (reitev naloge)
rem   - naivna.pas (naivna reitev)
rem   - besede.txt (datoteka z besedami)
rem   - rtk96sZ-test1.bat (pomona paketna datoteka).

ppc386 rtk95sZ.pas -Cr -gl
echo.
echo Pripravljam indeksne datoteke.
echo.
rtk95sZ

echo.
echo Reujem testne primere.
echo.
call rtk95sZ-test1.bat rtk95sZ > out.txt

ppc386 naivna.pas -Cr -gl
echo.
echo Reujem testne primere z naivno reitvijo.
echo.
call rtk95sZ-test1.bat naivna > naivna-out.txt

echo.
echo Primerjam dobljene reitve.
echo.
sort out.txt > outs.txt
sort naivna-out.txt > naivna-outs.txt
fc outs.txt naivna-outs.txt
