program Rop; { RTK 1996.2.3 }
const MaxDolzina = 100; 
type Niz = array[0..MaxDolzina - 1] of char; 

function KjeRezati(s: Niz; n: integer): integer; 

  procedure Nasl(i: integer; var j, i1: integer); 
  begin
    i1 := (i + 1) mod n; 
    while i1 <> i do 
      if (s[i1] <> 'b') and (s[i1] <> s[i]) then break
      else i1 := (i1 + 1) mod n; 
    j := (i1 + n - 1) mod n; 
    while j <> i do 
      if s[j] <> 'b' then break
      else j := (j + n - 1) mod n; 
    j := (j + 1) mod n; 
  end; {Nasl} 

  procedure Prikazi(PlenOd, Rez, PlenDo, Koliko: integer);
  var i: integer;
  begin
    Write('Moen rez: ');
    for i := 0 to n - 1 do begin
      if i = PlenOd then Write('<');
      if i = PlenDo then Write('>');
      if i = Rez then Write('|');
      Write(s[i]);
    end; {for}
    WriteLn('  (', Koliko, ')');
  end; {Prikazi}
  
var h, h1, i, j, j0, i1, j1, i2, j2, i3, b, bi, c: integer; 
begin
  h := 0; 
  while h <> n do   { poiimo prvi barvni biser } 
    if s[h] <> 'b' then break
    else h := h + 1; 
  if h = n then     { vse brezbarvno } 
    begin WriteLn('vse brezbarvno'); KjeRezati := 0; exit; end;
  Nasl(h, h1, i); Nasl(i, j, i1); 
  if i1 = i then    { nista prisotni in modra in rdea } 
    begin WriteLn('ena sama barva'); KjeRezati := i; exit; end;
  Nasl(i1, j1, i2); 
  if i2 = i then    { en kos modre in en kos rdee } 
    begin WriteLn('en kos vsake barve'); KjeRezati := i; exit; end;
  b := 0; bi := 0; j0 := j; 
  repeat 
    Nasl(i2, j2, i3); 
    c := i3 - j;   { izplen, e prereemo pred j1 } 
    if c <= 0 then c := c + n; 
    Prikazi(j, j1, i3, c);
    if c > b then begin b := c; bi := j1; end; 
    i := i1; j := j1; i1 := i2; j1 := j2; i2 := i3; 
  until j = j0; 
  KjeRezati := bi;     { poloaj najboljega izplena } 
end;

var Ogrlica: string; Ogrlica2: Niz; i, Kje: integer;
begin {Rop}
  while not Eof do begin
    ReadLn(Ogrlica);
    for i := 1 to Length(Ogrlica) do Ogrlica2[i - 1] := Ogrlica[i];
    Kje := KjeRezati(Ogrlica2, Length(Ogrlica));
    WriteLn('Reitev: ', Copy(Ogrlica, 1, Kje), ' ', 
            Copy(Ogrlica, Kje, Length(Ogrlica) - Kje));
  end; {while}
end. {Rop}
