program Stevec; { RTK 1997.Z.3 }
var 
  F: text; i, j, k: longint; 
  Km, Mali, KmDelta, M: longint; R: real; 
  Stevke, Stevke0: array[0..9] of integer; 
  Ostale: set of 0..9; Nasel: boolean; 

begin
  if ParamCount >= 1 then Assign(F, ParamStr(1))
  else Assign(F, 'input.txt'); 
  Reset(F); ReadLn(F, Km, R); Close(F);  
  
  { Pozor: uporabiti moramo Round, ne Trunc.  Slednji vedno zaokroa navzdol,  
    kar ni dobro, saj je lahko kakno decimalno tevilo, npr. 0,1, predstavljeno 
    z nekim priblikom, ki je manji od njega in je potem tudi njegov 
    desetkratnik manji od ustreznega celega tevila.  e bi ga zaokroili 
    navzdol, bi dobili za 1 premajhno vrednost. }
  Mali := Round(10 * R); KmDelta := 0; 
  while true do begin 

    { Katere tevke se ne pojavljajo na velikem tevcu? } 
    Ostale := [0..9]; j := Km;  
    for i := 0 to 5 do begin Ostale := Ostale - [j mod 10]; j := j div 10; end;
    { Shranimo jih v tabelo Stevke0. } 
    j := 0; for i := 0 to 9 do if i in Ostale then 
      begin Stevke0[J] := i; Inc(J); end;

    { e so ostale samo tiri tevke, jih poskusimo na vseh 4! = 24 nainov  
      sestaviti v stanje malega tevca. }
    Nasel := false; 
    if j = 4 then for i := 0 to 23 do begin 

      { Pripravimo (v tevilu M) i-to permutacijo naih tirih tevk. } 
      for j := 0 to 3 do Stevke[j] := Stevke0[j]; 
      j := i div 6; k := i mod 6; M := 1000 * Stevke[j]; 
      while j < 3 do begin Stevke[j] := Stevke[j + 1]; Inc(j)end;; 
      j := k div 2; k := k mod 2; Inc(M, 100 * Stevke[j]); 
      while j < 2 do begin Stevke[j] := Stevke[j + 1]; Inc(j)end;; 
      if k = 1 then Inc(M, 10 * Stevke[1] + Stevke[0]) 
      else Inc(M, 10 * Stevke[0] + Stevke[1]); 

      { Mogoe lahko do te vrednosti malega tevca pridemo tako, da ga med 
        vonjo v primernem trenutku resetiramo.  Vonja mora biti dovolj dolga, 
        da bo imel po resetiranju as priti od 0000 do vrednosti Mali. }
      if M div 10 <= KmDelta then 
        begin Nasel := true; break; end;
        
      { Mogoe pa bo dosegel mali tevec to vrednost v tem kilometru e kar 
        brez naega posredovanja.  V trenutnem kilometru bo imel vrednosti 
        od Mali do Mali + 9. }
      if (Mali <= M) and (M <= Mali + 9) then 
        begin Nasel := true; break; end; 
    
    end; {for i} 
    if Nasel then break; 

    { Prevozimo e en kilometer. } 
    Km := (Km + 1) mod 1000000; Mali := (Mali + 10) mod 10000; Inc(KmDelta); 

  end; {while}

  { Izpiimo rezultat. }
  for i := 0 to 5 do begin Stevke[i] := Km mod 10; Km := Km div 10; end;
  if ParamCount >= 2 then Assign(F, ParamStr(2))
  else Assign(F, 'output.txt'); 
  Rewrite(F);  
  for i := 5 downto 0 do Write(F, Stevke[i]); 
  WriteLn(F); Close(F); 
  
end. {Stevec} 
