program ZEnoRoko; { RTK 2001.1.1 }

  type Roka = (Leva, Desna); 
  function SKateroRoko(C: char): Roka;
  begin
    if UpCase(C) in ['Q', 'W', 'E', 'R', 'T', 
      'A', 'S', 'D', 'F', 'G',
      'Z', 'X', 'C', 'V', 'B',
      '1', '2', '3', '4', '5',
      '!', '@', '#', '$', '%'] 
    then SKateroRoko := Leva
    else SKateroRoko := Desna;
  end; {SKateroRoko}
  
var 
  TrenRoka, NovaRoka: Roka;
  StSTrenRoko, MaxZEnoRoko: integer;
  c: char; Prvi: boolean;
begin {ZEnoRoko}
  
  Prvi := true; StSTrenRoko := 0; MaxZEnoRoko := 0;
  TrenRoka := Leva; { Zaetna vrednost TrenRoka ni pomembna, 
    saj zaradi Prvi = true na prvo izvajanje spodnjega stavka if 
    ni ne vpliva, kasneje pa bomo spremenljivki TrenRoka e 
    priredili neko smiselno vrednost.  Vendar pa jo moramo 
    vendarle inicializirati e zdaj, saj standard za pascal 
    pravi, da spremenljivk z nedefinirano vrednostjo ne smemo
    uporabljati v izrazih (v naem primeru v NovaRoka <> TrenRoka). }
  while not (Eof or Eoln) do begin
  
    { Preberimo naslednji znak. }
    Read(c);
    NovaRoka := SKateroRoko(c);
    
    if (NovaRoka = TrenRoka) and not Prvi then
      { Z isto roko kot doslej natipkamo e en znak ve. }
      StSTrenRoko := StSTrenRoko + 1
    else begin
      { Zamenjamo roko.  Mogoe smo z dosedanjo roko 
        dosegli nov rekord. }
      if StSTrenRoko > MaxZEnoRoko then 
        MaxZEnoRoko := StSTrenRoko;
      StSTrenRoko := 1; TrenRoka := NovaRoka;
    end; {if}
      
    if Prvi then Prvi := false;
  end; {while}
  
  if StSTrenRoko > MaxZEnoRoko then 
    MaxZEnoRoko := StSTrenRoko;
  
  WriteLn('Dolina najdaljega podzaporedja: ', MaxZEnoRoko); 
end. {ZEnoRoko} 
