program PodobnostMedBesedili; { RTK 2001.3.6 }
const MaxD = 20; MaxBesed = 20; MaxDolz = 20;
type BesedaT = string[MaxDolz];
var StBesed: array[1..MaxD] of integer;
  Besede: array[1..MaxD, 1..MaxBesed] of BesedaT;
  StPojavitev: array[1..MaxD, 1..MaxBesed] of integer;
  Norma: array[1..MaxD] of integer;
  T: text; S: string; B: BesedaT;
  i, i2, j1, j2, k, kk, L, D: integer; { D = tevilo besedil }
  b1, b2: integer; { najpodobneji besedili doslej }
  Pod, bPod: real; { trenutna in najveja podobnost }
begin
  { Preberimo vhodno datoteko. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'docclust.in'); 
  Reset(T); ReadLn(T, D); b1 := 0; b2 := 0;
  for i := 1 to D do begin
    ReadLn(T, S); L := Length(S); j1 := 1; 
    StBesed[i] := 0;
    { Razreimo niz S na besede. }
    while j1 <= L do begin
      while j1 <= L do { preskoimo presledke }
        if S[j1] = ' ' then j1 := j1 + 1 else break;
      if j1 > L then break;
      j2 := j1;
      while j2 <= L do { preberimo besedo }
        if S[j2] = ' ' then break else j2 := j2 + 1;
      { Zdaj bomo besedo vstavili v zaporedje Besedila[i]. 
        e je e v njem, bomo samo poveali tevilo pojavitev. 
        Seznam besed naj bo urejen po abecedi. }
      k := 1; B := Copy(S, j1, j2 - j1); j1 := j2;
      while k <= StBesed[i] do
        if B <= Besede[i, k] then break else k := k + 1;
      if (k <= StBesed[i]) and (B = Besede[i, k]) then 
        StPojavitev[i, k] := StPojavitev[i, k] + 1
      else begin
        kk := StBesed[i]; while kk >= k do begin
          StPojavitev[i, kk + 1] := StPojavitev[i, kk]; 
          Besede[i, kk + 1] := Besede[i, kk]; kk := kk - 1;
        end; {while}
        Besede[i, k] := B; StPojavitev[i, k] := 1; 
        StBesed[i] := StBesed[i] + 1;
      end; {if}
    end; {while}
    Norma[i] := 0;
    for k := 1 to StBesed[i] do 
      Norma[i] := Norma[i] + StPojavitev[i, k] * StPojavitev[i, k];
    { Primerjajmo to besedilo z vsemi prejnjimi. }
    for i2 := 1 to i - 1 do begin
      Pod := 0; j1 := 1; j2 := 1;
      while (j1 <= StBesed[i]) and (j2 <= StBesed[i2]) do 
        if Besede[i, j1] = Besede[i2, j2] then begin
          Pod := Pod + StPojavitev[i, j1] * StPojavitev[i2, j2]; 
          j1 := j1 + 1; j2 := j2 + 1;
        end else if Besede[i, j1] < Besede[i2, j2] then j1 := j1 + 1
        else j2 := j2 + 1;
      Pod := Pod / Sqrt(Norma[i] * Norma[i2]);
      { Ali je to nov najpodobneji par besedil? }
      if (b1 <= 0) or (Pod > bPod) then
        begin b1 := i2; b2 := i; bPod := Pod; end;
    end; {for i2}
  end; {for i}
  Close(T);
  { Izpiimo rezultate. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'docclust.out'); 
  Rewrite(T); WriteLn(T, b1, ' ', b2); Close(T);
end. {PodobnostMedBesedili}
