program ProduktStevil; { RTK 2002.3.5 }
var sb, kb, bOd, bDo: longint; { najbolji doslej znan zmnoek }

  procedure Kandidat(s, k, iOd, iDo: longint);
  begin
    if (iDo >= iOd) and ((s > sb) or ((s = sb) and (s * k > sb * kb))) then
      begin sb := s; kb := k; bOd := iOd; bDo := iDo; end;
  end; {Kandidat}

var T: text; i, N, a, BlokOd, PrvaNeg, ZadnjaNeg, s, k, s1, k1, s2, k2, s3, k3: longint; 
begin
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'produkt.in'); 
  Reset(T); ReadLn(T, N); BlokOd := 0;
  for i := 1 to N + 1 do begin
    { Preberimo naslednje tevilo, a.  Na koncu zaporedja si
      mislimo e eno nilo, da nam kona prejnjo skupino tevil. }
    if i <= N then ReadLn(T, a) else a := 0;
    { Izrazimo a v obliki s * 2^e. }
    if a < 0 then begin s := -1; a := -a; end
    else if a > 0 then s := 1 else s := 0;
    k := 0; while a > longint(1) shl k do k := k + 1;
    { Zaetni kandidat za najbolji zmnoek naj bo kar prvo tevilo zaporedja. }
    if i = 1 then begin sb := s; kb := k; bOd := i; bDo := i; end;
    { s1 * 2^e1 = produkt v trenutnem bloku pred zadnjim negativnim t. 
      s2 * 2^e2 = produkt v trenutnem bloku po prvem negativnem t. 
      s3 * 2^e3 = produkt v trenutme bloku od vklj. zadnjega negativnega t. }
    if BlokOd = 0 then begin { inicializacija na zaetku bloka }
      s1 := 1; k1 := 0; s2 := 1; k2 := 0; s3 := 1; k3 := 0; 
      PrvaNeg := 0; ZadnjaNeg := 0; BlokOd := i; 
    end; {if}
    if s < 0 then begin { negativno tevilo }
      if PrvaNeg = 0 then PrvaNeg := i
      else begin s2 := s2 * s; k2 := k2 + k; end;
      s1 := s1 * s3; k1 := k1 + k3; s3 := s; k3 := k; ZadnjaNeg := i;
    end else if s > 0 then begin { pozitivno tevilo }
      if PrvaNeg > 0 then begin s2 := s2 * s; k2 := k2 + k; end;
      s3 := s3 * s; k3 := k3 + k; 
    end else begin { konec bloka }
      Kandidat(s1, k1, BlokOd, ZadnjaNeg - 1); { vse pred zadnjim negativnim tevilom }
      Kandidat(s2, k2, PrvaNeg + 1, i - 1); { vse po prvem negativnem tevilu }
      Kandidat(s1 * s3, k1 + k3, BlokOd, i - 1); { cel blok }
      if i <= N then Kandidat(s, k, i, i); { nila }
      BlokOd := 0; { zaenja se nov blok }
    end; {if}
  end; {for i}
  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'produkt.out'); 
  Rewrite(T); WriteLn(T, bOd, ' ', bDo); Close(T);
end. {ProduktStevil}
