program Krizanke; { RTK 2003.2.1 }

const Visina = 5; Sirina = 10; 
type KrizankaT = array[1..Visina, 1..Sirina] of char; 

procedure IzpisiBesede(Krizanka: KrizankaT); 

  { Delali se bomo, kot da so zunaj krianke same zvezdice. } 
  function Zvezdica(i, j: integer): boolean;  
  begin
    if (i < 1) or (j < 1) or (i > Visina) or (j > Sirina) 
    then Zvezdica := true else Zvezdica := Krizanka[i, j] = '*';  
  end; {Zvezdica} 

var i, j, k, Stevilka: integer; Vod, Nav: boolean; 
begin
  Stevilka := 0; 
  for i := 1 to Visina do for j := 1 to Sirina do 
    if not Zvezdica(i, j) then begin
      { Preverimo, e se v tem polju zaenja kakna beseda. } 
      Vod := Zvezdica(i, j - 1) and not Zvezdica(i, j + 1); 
      Nav := Zvezdica(i - 1, j) and not Zvezdica(i + 1, j); 
      if not (Vod or Nav) then continue; 
      Inc(Stevilka);  
      { Izpiimo vodoravno besedo. } 
      Write(Stevilka, ', vodoravno: '); k := j; 
      if not Vod then Write('-')  
      else while not Zvezdica(i, k) do 
        begin Write(Krizanka[i, k]); Inc(k); end;
      { Izpiimo navpino besedo. } 
      WriteLn; Write(Stevilka, ', navpino: '); k := i; 
      if not Nav then Write('-')  
      else while not Zvezdica(k, j) do 
        begin Write(Krizanka[k, j]); Inc(k); end; 
      WriteLn; 
    end; {if}
end; {IzpisiBesede} 

const Krizanka: KrizankaT = ( 
  'LOREM*IP*S', 
  'UM*DOL*ORS', 
  'ITAMET*CON', 
  'SETE*TUR*S', 
  'ADI*PSCING'); 

begin {Krizanke}
  IzpisiBesede(Krizanka); 
end. {Krizanke}
