program Knjige; { RTK 2003.3.5 }

  procedure ObdrziVecjo(var a: integer; b: integer);
    begin if b > a then a := b; end;

const MaxN = 1000; MaxM = 100; MaxD = 100;
var T: text; n, m, d, ni, mi, g, b, bb: integer;
    di: array[1..MaxN] of integer;
    f: array[1..MaxM, 0..MaxD] of integer;
begin
  { Preberimo vhodne podatke. }
  if ParamCount >= 1 then Assign(T, ParamStr(1)) 
  else Assign(T, 'knjige.in');
  Reset(T); ReadLn(T, n, m, d);
  for ni := 1 to n do Read(T, di[ni]);
  Close(T);
  { 0 knjig. }
  for mi := 1 to m do for g := 0 to d do f[mi, g] := 0;
  { Dodajajmo knjige. }
  for ni := 1 to n do begin
    b := 0; { Najbolji rezultat za 'ni - 1' knjig in 0 polic. }
    for mi := 1 to m do begin
      { 'ni' knjig in 'mi' polic.  Ko raunamo za nek 'g',
        bomo potrebovali rezultat za 'ni - 1' knjig, 'mi' polic
        in razne manje 'g', tako da je koristno iti od vejih
        'g' proti manjim, da si ne bomo sproti kvarili starih
        rezultatov, ki jih bomo e potrebovali.  Zapomnimo si
        tudi najbolji rezultat za 'ni - 1' knjig in 'mi' polic. }
      bb := f[mi, d];
      for g := d downto di[ni] do begin
        { Lahko knjige 'ni' sploh ne vzamemo.  Potem je rezultat
          za 'ni' knjig in 'mi' polic enak kot za 'ni - 1' knjig
          in 'mi' polic, ta pa je e v f[mi, g]. }
        { Lahko dodamo knjigo 'ni' na polico 'mi', pri emer
          je prej na njej e kakna knjiga.  Reitve za 'ni - 1'
          knjig in 'mi' polic in majhne g so trenutno e v f[mi]. }
        ObdrziVecjo(f[mi, g], 1 + f[mi, g - di[ni]]);
        { Lahko dodamo knjigo 'ni' na polico 'mi' kot prvo. 
          Najbolji rezultat za 'ni - 1' knjig in 'mi - 1' polic
          je trenutno v b. }
        ObdrziVecjo(f[mi, g], 1 + b);
      end; {for g}
      b := bb; { Najbolji rezultat za 'ni - 1' knjig in 'mi' polic. }
    end; {for mi}
  end; {for ni}
  { Izpiimo rezultat. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) 
  else Assign(T, 'knjige.out');
  Rewrite(T); WriteLn(T, f[mi, d]); Close(T);
end. {Knjige}
