program Ukazi; { RTK 1988.2.2 }
const MaxDolz = 20; 
type BesedaT = packed array[1..MaxDolz] of char; 

function AliJeUkaz(Model, Niz: BesedaT): boolean; 
var 
  iNiz: integer;          { tevec znakov v nizu } 
  iModel: integer;        { tevec znakov v modelu kljune besede }  
  VseObv: boolean;        { ali smo obdelali obvezni del ukaza } 
  SeUjema: boolean;       { ali se obdelani del niza ujema z modelom } 
  Konec: boolean;         { ali smo prili do konca niza } 
begin
  iNiz := 1; iModel := 1; 
  VseObv := false; SeUjema := true; Konec := false; 
  while SeUjema and not Konec do begin 
    if Model[iModel] = '*' then 
      begin VseObv := true; iModel := iModel + 1 end
    else if Niz[iNiz] = ' ' then Konec := true
    else if Niz[iNiz] <> Model[iModel] then SeUjema := false
    else begin iNiz := iNiz + 1; iModel := iModel + 1 end;
  end; {while}
  AliJeUkaz := VseObv and SeUjema; 
end; {AliJeUkaz}

var Model, Niz: string;
begin {Ukazi}
  if ParamCount >= 2 then begin
    Model := ParamStr(1); Niz := ParamStr(2);
  end else begin
    Write('Vnesi model: '); ReadLn(Model);
    Write('Vnesi niz:   '); ReadLn(Niz);
  end; {if}
  Write('AliJeUkaz(''', Model, ''', ''', Niz, ''') = ');
  if AliJeUkaz(Model + ' ', Niz + ' ') then WriteLn('da') else WriteLn('ne');
end. {Ukazi}
