program Valovanje; { RTK 1992.2.3 }
{const 
  MinInt = -32768; 
  MaxInt = 32767;}

function MojVal(Str: string; StrL: integer; var n: integer): boolean; 
const 
  MaxN = 3276 {MaxInt div 10}; ModMaxN = 7 {MaxInt mod 10}; 
  MinN = -3276 {MinInt div 10}; ModMinN = 8 {MinInt mod 10}; 
var 
  j, Dig: integer; 
  ok, Cont: boolean; 
  Sign: (Plus, Minus); 
begin
  ok := true; Sign := Plus; n := 0; j := 1; 
  { Preskoimo presledke na zaetku niza. } 
  Cont := true; 
  while Cont and (j <= StrL) do 
    if Str[j] <> ' ' then Cont := false else j := j + 1; 
  { Preberimo predznak (e je prisoten). } 
  if Str[j] in ['+', '-'] then 
    begin if Str[j] = '-' then Sign := Minus;   j := j + 1; end;
  { Berimo tevke; pazimo, da ne bomo dobili prevelike ali premajhne vrednosti. } 
  Cont := true; Dig := -1;
  while Cont and (j <= StrL) do 
    if not (Str[j] in ['0'..'9']) then Cont := false
    else begin 
      Dig := Ord(Str[j]) - Ord('0'); 
      case Sign of 
        Plus: 
          if (n > MaxN) or ((n = MaxN) and (Dig > ModMaxN)) then ok := false; 
        Minus: begin
          if (n < MinN) or ((n = MinN) and (Dig > ModMinN)) then ok := false; 
          Dig := -Dig; 
        end; {Minus}
      end; {case} 
      if not ok then Cont := false
      else begin n := 10 * n + Dig; j := j + 1; end;
    end; {else, while} 
  if Dig = -1 then ok := false; { Namesto tevk smo naleteli na nekaj drugega. }
  { Preskoimo presledke na koncu niza. } 
  Cont := true; 
  while Cont and (j <= StrL) do 
    if Str[j] <> ' ' then Cont := false else j := j + 1; 
  if j <= StrL then ok := false; { Poleg presledkov je za tevilko e nekaj drugega. }
  MojVal := ok; 
end; {MojVal} 

procedure Test(S: string);
var i: integer;
begin
  Write('Val("', S, '") = ');
  if not MojVal(S, Length(S), i) then WriteLn('napaka')
  else WriteLn(i);
end; {Test}

begin {Valovanje}
  if ParamCount >= 1 then Test(ParamStr(1))
  else begin
    Test('0');
    Test('-0');
    Test('+0');
    Test('1');
    Test('+1');
    Test('-1');
    Test('123');
    Test('+123');
    Test('-123');
    Test('12345');
    Test('+12345');
    Test('-12345');
    Test('32766');
    Test('32767');
    Test('32768');
    Test('32769');
    Test('+32766');
    Test('+32767');
    Test('+32768');
    Test('+32769');
    Test('-32766');
    Test('-32767');
    Test('-32768');
    Test('-32769');
    Test('   123');
    Test('   123   ');
    Test('123   ');
    Test('   -123');
    Test('   -123   ');
    Test('-123   ');
    Test('   -   123');
    Test('   -   123   ');
    Test('-   123   ');
    Test('   a-123   ');
    Test('  a -123   ');
    Test('   -a123   ');
    Test('   -a123   ');
    Test('   -a123   ');
    Test('   -1a23   ');
    Test('   -123a   ');
    Test('   -123 a  ');
    Test('   -123   a');
  end; {if}
end. {Valovanje}