program UrejanjeSvedrov; { RTK 1992.2.4 }

{ Vmesnik, ki ga vidi podprogram Uredi. }
procedure Zavrti; forward;
procedure Zamenjaj; forward;
function StrojPrazen: boolean; forward;
function Primerjaj: boolean; forward;

procedure Uredi; 
var 
  Konec: boolean; 
begin
  repeat 
    Konec := true; 
    Zamenjaj; 
    Zavrti; 
    repeat 
      while Primerjaj do begin 
        Zavrti; 
        Konec := false; 
      end; {while}
      Zamenjaj; 
      Zavrti; 
    until StrojPrazen; 
  until Konec; 
end; {Uredi} 

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira delovanje stojala in vrtalnika.                }
{-----------------------------------------------------------------------------}

const MaxN = 100;
var 
  { Svedri, navedeni v smeri urinega kazalca. }
  Svedri: array[1..MaxN] of integer;
  N, Polozaj, vStroju: integer;

procedure PrikaziStanje(S: string);
var i: integer;
begin
  Write(S); 
  for i := 1 to N do begin
    if i = Polozaj then Write('>') else Write(' ');
    if Svedri[i] = 0 then Write('--') else Write(Svedri[i]:2);
    if i = Polozaj then Write('<') else Write(' ');
  end; {if}
  Write('   V stroju: ');
  if vStroju = 0 then Write('--')
  else Write(vStroju:2);
  WriteLn('.');
end; {PrikaziStanje}

procedure Zavrti;
begin
  { e smo imeli zdaj pred sabo sveder Svedri[Polozaj]
    in smo stojalo zavrteli v smeri urinega kazalca,
    nam je zdaj pred nos priel sveder, ki je bil
    (gledano v smeri urinega kazalca) tik pred
    dosedanjim, torej Svedri[Polozaj - 1]. }
  Polozaj := Polozaj - 1;
  if Polozaj = 0 then Polozaj := N;
  PrikaziStanje('Zavrti     '); ;
end; {Zavrti}

procedure Zamenjaj;
var t: integer;
begin
  t := Svedri[Polozaj]; Svedri[Polozaj] := vStroju; vStroju := t;
  PrikaziStanje('Zamenjaj   '); 
end; {Zamenjaj}

function StrojPrazen: boolean;
begin
  StrojPrazen := vStroju = 0;
end; {StrojPrazen}

function Primerjaj: boolean;
begin
  Primerjaj := vStroju < Svedri[Polozaj];
end; {Primerjaj}

var i: integer;
begin {UrejanjeSvedrov}
  if ParamCount > 0 then begin
    Val(ParamStr(1), N, i); if i > 0 then N := 10;
  end else N := 10;
  WriteLn('tevilo svedrov: ', N, '.');

  { Nakljuno premeajmo svedre. }
  for i := 1 to N do begin
    Polozaj := Random(i) + 1;
    Svedri[i] := Svedri[Polozaj];
    Svedri[Polozaj] := i;
  end; {for}
  Polozaj := Random(N) + 1; vStroju := 0;

  PrikaziStanje('Zaetek    '); 
  Uredi;
  PrikaziStanje('Konec      '); 
end. {UrejanjeSvedrov}
