program Zlogi; { RTK 1994.2.1 }
const MaksDolzinaNiza = 15; { najveja dolzina niza } 
type NizT = array[1..MaksDolzinaNiza] of char; 

function Samoglasnik(Crka: char): boolean; 
begin
  Samoglasnik := Crka in ['a', 'e', 'i', 'o', 'u']; 
end; {Samoglasnik} 

function StZlogov(s: NizT): integer; 
var i, z: integer; 
begin
  i := 2; z := 0; 
  while s[i] <> ' ' do begin 
    if Samoglasnik(s[i]) then z := z + 1 
    else if (s[i] = 'r') and 
         not (Samoglasnik(s[i - 1]) or Samoglasnik(s[i + 1])) then 
      z := z + 1; 
    i := i + 1; 
  end; {while}
  if z = 0 then StZlogov := 1 else StZlogov := z; 
end; {Stej} 

begin {Zlogi}
  if ParamCount >= 1 then
    WriteLn(StZlogov(' ' + ParamStr(1) + ' '))
  else begin
    WriteLn(StZlogov(' matematika    ')); 
    WriteLn(StZlogov(' z             ')); 
    WriteLn(StZlogov(' prstan        ')); 
  end; {if}
end. {Zlogi} 