program Postavi; { RTK 1996.2.2 }
const MaxStOvir = 100;
var 
  Zacetek: array[1..MaxStOvir] of integer; 
    { razdalja med zaetkom kabla in zaetkom ovire (v metrih) } 
  Konec: array[1..MaxStOvir] of integer; 
    { razdalja med zaetkom kabla in koncem ovire (v metrih) } 
  StOvir: integer;   { tevilo ovir }
  Ovira: integer;    { tevec } 
  Kje: longint;      { mona lokacija prvega ojaevalnika} 
begin
  { Obdelajmo ve testnih primerov.  e dobimo StOvir = 0, nehamo. }
  while not Eof do begin
    Kje := 0; 
    ReadLn(StOvir);
    if StOvir <= 0 then break;
    for Ovira := 1 to StOvir do begin 
      { Ojaevalnik ne sme biti na poloaju x, e je
        Zacetek[Ovira] <= x < Konec[Ovira]. }
      ReadLn(Zacetek[Ovira], Konec[Ovira]);
      Zacetek[Ovira] := Zacetek[Ovira] mod 4000; 
      Konec[Ovira] := Konec[Ovira] mod 4000; 
      { e ovira pokriva kak vekratnik tevila 4000,
        mora biti prvi ojaevalnik med Konec mod 4000 
        in Zacetek mod 4000. }
      if (Zacetek[Ovira] >= Konec[Ovira]) and (Konec[Ovira] > Kje) then 
        Kje := Konec[Ovira];  
    end; {for}
    Ovira := 1; 
    repeat 
      { e je Kje < Zacetek[Ovira], nam trenutna ovira
        ne povzroa teav.  e je to ena od tistih, ki
        imajo Zacetek < Konec, je sploh v redu, e pa je
        ena od tistih, ki imajo Konec < Zacetek, so
        sprejemljivi poloaji vsi od Konec do Zacetek-1
        in na Kje oitno je tak, saj smo za Kje >= Konec
        poskrbeli e v gornji zanki for, Kje < Zacetek
        pa oitno tudi velja.  Skratka, s to oviro se bo
        treba ukvarjati le, e je Kje >= Zacetek. }
      if Zacetek[Ovira] <= Kje then begin 
        { Vsak manji Kje bi bil nesprejemljiv zaradi doslej
          upotevanih ovir.  Tale pa oitno tudi ni
          sprejemljiv zaradi trenutne ovire. }
        if Konec[Ovira] <= Zacetek[Ovira] then begin 
          { Zaradi te ovire so nesprejemljivi poloaji
            Zacetek[Ovira]..3999 in 0..Konec[Ovira]-1.
            Ker pa je Kje >= Zacetek in manji Kje tudi niso
            sprejemljivi, je problem nereljiv. }
          Kje := 4000; Ovira := StOvir + 1 
        end else if Konec[Ovira] > Kje then begin 
          { Zaradi te ovire so nesprejemljivi poloaji
            Zacetek[Ovira]..Konec[Ovira]-1.  Torej postavimo
            Kje na Konec[Ovira].  S tem smo mogoe padli
            na sredo kakne od e prej pregledanih ovir,
            zato postavimo Ovira na 1, da jih bomo pregledali
            spet od zaetka. }
          Kje := Konec[Ovira]; Ovira := 0 
        end; {if}
      end;
      Ovira := Ovira + 1; 
    until Ovira > StOvir; 
    if Kje < 4000 then 
      WriteLn('Prvi ojaevalnik naj bo na razdalji ', Kje, ' metrov.') 
    else WriteLn('Problem je nereljiv.'); 
  end; {while}
end. {Postavi} 
