program Poskakovanje; { RTK 2000.2.4 }

  { Prebere eno vrstico.  V njej naj bi bila 
    koda in ime reprezentance, loena z enim presledkom. }
  procedure PreberiPodatek(var T: text; var Ime: string; var Koda: integer);
  var S: string; i, j: integer;
  begin
    ReadLn(T, S);
    i := 1; while i <= Length(S) do 
      if S[i] = ' ' then break else i := i + 1;
    Val(Copy(S, 1, i - 1), Koda, j);
    Ime := Copy(S, i + 1, Length(S) - i);
  end;

const MaxKoda = 999;
var 
  Uvrstitev, NajvecjiSkok, Najboljsa: integer; T: text;
  ImeReprezentance: string; KodaReprezentance: integer;
  Ime: array[1..MaxKoda] of string;
  Skok: array[1..MaxKoda] of integer;
begin {Poskakovanje}

  Uvrstitev := 0; 
  Assign(T, 'stanje98.txt'); Reset(T);
  while not Eof(T) do begin 
    Uvrstitev := Uvrstitev + 1; 
    PreberiPodatek(T, ImeReprezentance, KodaReprezentance); 
    Ime[KodaReprezentance] := ImeReprezentance; 
    Skok[KodaReprezentance] := Uvrstitev; 
  end; {while}
  Close(T);
  
  Uvrstitev := 0; 
  NajvecjiSkok := -1; 
  Assign(T, 'stanje99.txt'); Reset(T);
  while not Eof(T) do begin 
    Uvrstitev := Uvrstitev + 1; 
    PreberiPodatek(T, ImeReprezentance, KodaReprezentance); 
    Skok[KodaReprezentance] := Skok[KodaReprezentance] - Uvrstitev; 
    if Skok[KodaReprezentance] > NajvecjiSkok then begin 
      NajvecjiSkok := Skok[KodaReprezentance]; 
      Najboljsa := KodaReprezentance; 
    end; {if}
  end; {while}
  WriteLn('Najbolja je reprezentanca ', Ime[Najboljsa], 
          ', ki je naredila skok za ', Skok[Najboljsa], ' mest.'); 
end. {Poskakovanje}
