program Ovojnica; { RTK 2000.3.3 }
type Tocka = record x, y: real end; 
const MaxN = 100; 
var p: array[1..MaxN + 1] of Tocka; N: integer;
    i, Min, M: integer; t: Tocka; 
begin
  { Preberimo koordinate tok. }
  ReadLn(N);
  for i := 1 to N do ReadLn(p[i].x, p[i].y);
  
  { Poiimo najnije leeo toko; ta bo gotovo na 
    robu ovojnice. }
  Min := 1; 
  for i := 2 to N do 
    if p[i].y < p[Min].y then Min := i; 
  M := 0; 
  { Na konec seznama bomo dali e eno kopijo te toke,
    ker bomo morali ovojnico e speljati nazaj do nje. }
  p[N + 1] := p[Min]; 
  
  repeat 
    { Na ovojnici e imamo toke p[1..M] v tem vrstnem redu, 
      vemo pa tudi, da bo p[Min] naslednja.  Torej jo 
      premaknimo v p[M + 1].}
    M := M + 1; t := p[M]; p[M] := p[Min]; p[Min] := t; 
    Min := M + 1; 
    { Poglejmo zdaj, katera od preostalih tok, torej p[M..N + 1] 
      (na mestu N + 1 imamo kopijo prve toke z ovojnice, ker 
      bomo morali ovojnico e speljati nazaj do nje), oklepa 
      najmanji kot s staro smerjo.  Obenem vemo, da bo naklon 
      nove stranice veji kot naklon prejnje.  Da nam ne bo treba
      raunati teh naklonov v kotih, si bomo pomagali z znanim
      pravilom, ki pove, e lei toka i na desni strani vektorja
      od p[M] do p[Min]: e je tako, moramo namesto Min vzeti i. }
    for i := M + 1 to N + 1 do 
      if (p[i].x - p[M].x) * (p[Min].y - p[M].y) <
         (p[i].y - p[M].y) * (p[Min].x - p[M].x) then Min := i;
    { e je naslednja toka N + 1, smo prili naokoli in lahko konamo. }
   until Min = N + 1; 
   
   { Izpiimo ovojnico. }
   WriteLn(M);
   for i := 1 to M do WriteLn(p[i].x:0:2, ' ', p[i].y:0:2);
end. {Ovojnica} 
