program Kletke1; { RTK 2001.3.4 }
{ as izvajanja na 16 testnih primerih: 0.43 s }
const MaxM = 100; MaxN = 100; MaxKletk = MaxM * MaxN;
      Zgoraj = 1; Levo = 8;
var 
  { Velikost[k] = velikost (skupno tevilo celic) kletke k }
  Velikost: array[1..MaxKletk] of integer;
  { Kletka[x] = kletka, ki ji pripada celica x }
  Kletka: array[1..MaxM] of integer; 
  { statistike, ki jih bomo morali na koncu izpisati }
  Najvecja, Najmanjsa, StKletk, StBarv: integer;
  M, N: integer; { M = irina mree, N = viina }
  T: text; Celica, y, x, xx, k, kk: integer;
begin
  { Preberimo velikost mree. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'kletke.in'); 
  Reset(T); ReadLn(T, M, N);
  StBarv := 0;
  { Preglejmo celo mreo. }
  for y := 1 to N do begin
    for x := 1 to M do begin
      Read(T, Celica); Celica := Celica and (Zgoraj or Levo);
      if Celica = 0 then 
        { Celica ima zidova zgoraj in levo; ustanovimo zanjo novo kletko. }
        begin StBarv := StBarv + 1; k := StBarv; end
      else if Celica = Zgoraj then 
        k := Kletka[x] { Celica pripada isti kletki kot tista nad njo. }
      else if Celica = Levo then 
        k := Kletka[x - 1] { Celica pripada isti kletki kot tista levo od nje. }
      else { Zlijmo kletko nad njo in tisto levo od nje
             (e nista to e zdaj ena in ista kletka). }
        if Kletka[x] <> Kletka[x - 1] then begin
          k := Kletka[x - 1]; kk := Kletka[x];
          for xx := 1 to M do if Kletka[xx] = kk then Kletka[xx] := k;
          Velikost[k] := Velikost[k] + Velikost[kk]; Velikost[kk] := 0;
        end; {if}
      { Trenutna celica pripada kletki k. }
      Kletka[x] := k; Velikost[k] := Velikost[k] + 1;
    end; {for x}
    ReadLn(T);
  end; {for y}
  Close(T);
  { Izraunajmo razne statistike.  Kletke, ki so pri zlivanju postale
    del kakne veje, imajo zdaj velikost 0 in jih ne smemo upotevati. }
  Najvecja := 0; Najmanjsa := M * N; StKletk := 0;
  for k := 1 to StBarv do if Velikost[k] > 0 then begin
    StKletk := StKletk + 1;
    if Velikost[k] > Najvecja then Najvecja := Velikost[k];
    if Velikost[k] < Najmanjsa then Najmanjsa := Velikost[k];
  end; {for k}
  { Izpiimo rezultate. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'kletke.out'); 
  Rewrite(T); WriteLn(T, StKletk); WriteLn(T, Najmanjsa); WriteLn(T, Najvecja); Close(T);
end. {Kletke1}
