program IskanjeGesla; { RTK 2002.2.3 }
{ Podprogram Test v tej reitvi kot pravo geslo teje 
  prvi parameter iz ukazne vrstice, torej ParamStr(1). }

  function Test(Geslo: string): boolean; 
  begin
    if ParamCount >= 1 then Test := Geslo = ParamStr(1)
    else Test := false;
  end; {Test}

{ Naloga sicer zahteva Najkrajse = 3, Najdaljse = 8.
  Vendar je potem mogoih toliko gesel (pribl. 1.67 * 10^14), 
  da program zlepa niesar ne najde.  Najkrajse = 2 in 
  Najkrajse = 4 pa omogoata malo obvladljivejih 7552480 gesel. }
const Najkrajse = 2; Najdaljse = 4; 
type KajIma = set of (Crko, Stevko);  
var Geslo: string; Nasel: boolean; 
    Stevec: int64;

procedure Test2(Dolzina: integer);  
begin
  Inc(Stevec);
  Geslo[0] := Chr(Dolzina); 
  if Test(Geslo) then begin 
    WriteLn('Nael sem geslo: ', Geslo, 
            '; t. poskusov: ', Stevec);
    Nasel := true; 
  end; {if}
end; {Test2} 

procedure Generiraj(Mesto: integer; Ima: KajIma); 
var i, Mala: integer; 
begin
  { V geslu je trenutno Mesto - 1 znakov.  Na indeks Mesto
    lahko postavimo rko, razen e ni to zadnje mono 
    mesto in so v nizu doslej same rke. }
  if (Mesto < Najdaljse) or (Stevko in Ima) then 
    for Mala := 0 to 1 do for i := 0 to 25 do begin 
      Geslo[Mesto] := Chr(Ord('A') + Mala * (Ord('a') - Ord('A')) + i); 
      { Geslo ima zdaj Mesto znakov.  e je to e najveja
        mona dolina, bomo geslo takoj preizkusili (Test2),
        drugae pa rekurzivno kliemo podprogram Generiraj,
        da ga bo poskusilo e podaljati. }
      if Mesto = Najdaljse then Test2(Mesto) 
                           else Generiraj(Mesto + 1, Ima + [Crko]);
      if Nasel then exit; 
    end; {for}
  { Namesto rke lahko na indeks Mesto postavimo tudi tevilko.
    Ta primer je drugae isto tak kot zgornji za rke. }
  if (Mesto < Najdaljse) or (Crko in Ima) then 
    for i := 0 to 9 do begin 
      Geslo[Mesto] := Chr(Ord('0') + i); 
      if Mesto = Najdaljse then Test2(Mesto) 
                           else Generiraj(Mesto + 1, Ima + [Stevko]);
      if Nasel then exit; 
    end; {for}
  { Doslej smo preizkusili vse nize, ki jih je mogoe iz
    dosedanjega dela gesla (Mesto - 1 znakov) dobiti z 
    dodajanjem enega ali ve znakov.  Ostane e monost,
    da geslu ni ne dodamo, ampak ga kar preizkusimo takega,
    kot je (torej dolgega le Mesto - 1 znakov).  Pred tem
    seveda preverimo, e ni prekratko in e ima tako rke
    kot tevke. }
  if (Mesto > Najkrajse) and (Ima = [Crko, Stevko]) then 
    Test2(Mesto - 1);
end; {Generiraj} 

begin {IskanjeGesla}
  Stevec := 0;
  Generiraj(1, []);  
  if not Nasel then 
    WriteLn('t. poskusov: ', Stevec, ', a brez uspeha.');
end. {IskanjeGesla} 
