program RadarZUrejenoTabelo; { RTK 2003.1.4 }
const N = 20; 
var Tabela: array[1..N + 1] of real; 
    T: text; x: real; i: integer; 
begin
  { Odprimo vhodno datoteko. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'podatki.txt');
  Reset(T); 
  { Berimo podatke in sproti pomnimo 20 najvejih. }
  for i := 1 to N do Tabela[i] := 0;
  while not Eof(T) do begin 
    ReadLn(T, x); 
    { Radi bi imeli manje elemente na koncu tabele.  Torej, 
      kolikor je na koncu tabele elementov, ki so manji od x, 
      jih premaknimo za eno mesto naprej. Prav zato je tabela 
      nala za eno celico dalja (ima N + 1 namesto N celic). }
    i := N; 
    while i > 0 do 
      if Tabela[i] >= x then break
      else begin Tabela[i + 1] := Tabela[i]; Dec(i); end;
    { Zdaj vemo, da je Tabela[i] >= x, tako da moramo
      x postaviti eno mesto za njim. }
    Tabela[i + 1] := x; 
  end; {while}
  Close(T); 
  { Izpiimo 20 najvejih meritev. }
  for i := 1 to N do WriteLn(Tabela[i]:0:2); 
end. {RadarZUrejenoTabelo} 
