program Sbn; { RTK 2004.3.2 }

{ Preprosta implementacija urejanja z izbiranjem.
  Za n registrov dobimo 3n(n-1)/2 + 1 ukazov dolg program. }

var T: text; i, j, n: integer;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'sbn.in');
  Reset(T); ReadLn(T, n); Close(T);
  if ParamCount >= 2 then Assign(T, ParamStr(2)) else Assign(T, 'sbn.out');
  Rewrite(T);
  for i := 1 to n - 1 do 
    { Cilj notranje zanke je spraviti v r[i] najmanjo izmed 
      vrednosti r[i..n]. }
    for j := i + 1 to n do begin
      { e je r[i] < r[j], skoi na end_i_j. }
      WriteLn(T, 'sbn r256, r', i, ', r', j, ', _', i, '_', j);
      { Sicer zamenjaj vrednosti registrov r[i] in r[j]. }
      WriteLn(T, 'sbn r', j, ', r', i, ', 0');    { r[j] := r[i]. }
      { r[i] := r[i] - (r[i] - stara vrednost r[j]). }
      WriteLn(T, 'sbn r', i, ', r', j, ', r256');
      Write(T, '_', i, '_', j, ': ');
    end; {for j}
  { Izpiimo e en NOP -- le toliko, da imamo kam pripeti zadnjo labelo. }
  WriteLn(T, 'sbn r255, r255, r255'); 
  Close(T);
end. {Sbn}
