program Palindromi; { RTK 2003.X.4 }
const MaxDolz = 256;
var 
  s: string;
  { D[id] vsebuje seznam elementov mnoice D(i), D[1 - id] pa mnoice D(i - 1). }
  D: array[0..1, 1..MaxDolz + 1] of integer; 
  nD: array[0..1] of integer; { nD[.] = velikost mnoice D[.] }
  f, fKako: array[0..MaxDolz] of integer;
  i, j, id, dd: integer;
begin
  ReadLn(s);
  id := 0; nD[id] := 0; f[0] := 0; 
  for i := 1 to Length(s) do begin
    id := 1 - id; nD[id] := 2; D[id, 1] := 0; D[id, 2] := 1;
    { V tabeli D[1 - id] je mnoica D(i - 1).   V tabeli D[id] pa
      bomo pripravili mnoico D(i); zaenkrat smo dodali vanjo tevili 0 in 1. }
    f[i] := f[i - 1]; fKako[i] := 1; { e ne uporabimo palindroma s koncem pri s[i] }
    for j := 1 to nD[1 - id] do begin
      dd := D[1 - id, j]; { trenutni element mnoice D(i - 1) }
      if dd >= i - 1 then continue;
      if s[i - dd - 1] <> s[i] then continue;
      { Dodajmo dd + 2 v mnoico D(i). }
      nD[id] := nD[id] + 1; D[id, nD[id]] := dd + 2;
      if f[i - dd - 2] + dd + 2 > f[i] then { nova najbolja reitev }
        begin f[i] := f[i - dd - 2] + dd + 2; fKako[i] := dd + 2 end;
    end; {for j}
    if false then begin
      WriteLn('Palindromi s koncem pri s[', i, '] = ', s[i], ' (', nD[id], '); f[', i, '] = ', f[i], ', fKako[', i, '] = ', fKako[i]);
      for j := 1 to nD[id] do begin
        dd := D[id, j];
        while dd > 0 do begin dd := dd - 1; Write(s[i - dd]) end;
        WriteLn;
      end; {for j}
    end; {if}
  end; {for i}
  { Rekonstruirajmo reitev.  V tabelo D[0] bomo pisali indekse, na katerih
    se konajo uporabljeni polinomi. }
  nD[0] := 0; i := Length(s);
  while i > 0 do begin
    nD[0] := nD[0] + 1; D[0, nD[0]] := i;
    i := i - fKako[i];
  end; {while}
  for j := nD[0] downto 1 do begin
    i := D[0, j]; dd := fKako[i]; if dd = 1 then continue;
    if false then Write('Palindrom s[', i - dd + 1, '..', i, ']: ');
    { V najbolji reitvi je uporabljen palindrom doline dd s koncem pri i. }
    while dd > 0 do begin dd := dd - 1; Write(S[i - dd]) end;
    Write(' ');
  end; {for j}
  WriteLn;
end. {Palindromi}
